package com.vendor.loader.ui.ssu;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.vendor.loader.Messages;
import com.vendor.loader.controler.GlobleControler;
import com.vendor.loader.model.PartitionItem;
import com.vendor.loader.struct.UpgradeFileInfo;
import com.vendor.loader.ui.AbstractComposite;
import com.vendor.loader.ui.ControlFactory;
import com.vendor.loader.ui.FileField;
import com.vendor.loader.ui.ssu.SsuPackageOptionsInfoGroup;
import com.vendor.loader.ui.ssu.SsuUpgradeInfoGroup;
import com.vendor.loader.util.FileHelper;
import com.vendor.loader.util.FileUtil;
import com.vendor.loader.util.InvalidDataFormatException;
import com.vendor.loader.util.StringUtil;
import com.vendor.loader.util.ssu.SsuIniFileParser;
import com.vendor.loader.util.ssu.SsuPackageOptions;
import java.awt.Toolkit;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.apache.commons.configuration2.PropertiesConfiguration;
import org.apache.commons.configuration2.ex.ConfigurationException;
import org.dom4j.DocumentException;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.osgi.util.NLS;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;

public class SsuLoaderComposite extends AbstractComposite {
  public SsuLoaderComposite(Composite parent, int style) {
    super(parent, style);
  }
  
  private static final String[] CHIPS = new String[] { "chip 0" };
  
  private static final String[] INI_FILTER_NAMES = new String[] { "xml Files(*.xml)", "ini Files (*.ini)" };
  
  private static final String[] INI_FILTER_EXTS = new String[] { "*.xml", "*.ini" };
  
  private SsuUpgradeInfoGroup upgradeInfo;
  
  private SsuPackageOptionsInfoGroup packageOptionsInfo;
  
  private FileField ssuTsFileField;
  
  private Button ssuTsButton;
  
  private void createTsGroup(Composite parent, String path) {
    String title = Messages.LoaderComposite_49;
    Composite group = createGroup(parent, title, 4);
    this.ssuTsFileField = new FileField(group, Messages.LoaderComposite_50, 80, Messages.LoaderComposite_51, 80, 268443648, "ssuTsFileField");
    if (path == null) {
      this.ssuTsFileField.setDefaultFileName(GlobleControler.intance.SSU_TS);
    } else {
      this.ssuTsFileField.setDefaultFileName(path);
    } 
    this.ssuTsFileField.setFileExtensions(new String[] { "*.ts", "*.*" });
    this.ssuTsButton = ControlFactory.createPushButton(group, Messages.LoaderComposite_53);
    this.ssuTsButton.addSelectionListener((SelectionListener)new Object(this));
  }
  
  protected Composite createGroup(Composite parent, String title, int num) {
    return (Composite)ControlFactory.createGroup(parent, title, num);
  }
  
  protected void createPackageOptions(Composite container) {
    Composite group = createGroup(container, Messages.PackageOptions, 8);
    this.packageOptionsInfo = new SsuPackageOptionsInfoGroup(group);
  }
  
  protected void createUpgradeInfoGroup(Composite container) {
    Composite group = createGroup(container, Messages.UpgradeInfoGroup_0, 8);
    this.upgradeInfo = new SsuUpgradeInfoGroup(group);
  }
  
  protected void saveIni(String path) {
    if (!validateInput())
      return; 
    FileDialog dlg = new FileDialog(getShell(), 8196);
    dlg.setFilterNames(INI_FILTER_NAMES);
    dlg.setFilterExtensions(INI_FILTER_EXTS);
    dlg.setFileName(path);
    dlg.setOverwrite(true);
    String fileName = dlg.open();
    if (fileName == null || fileName.isEmpty())
      return; 
    if (fileName.toUpperCase().indexOf("INI") > 0) {
      String file = this.ssuTsFileField.getFilePath();
      PropertiesConfiguration propertie = new PropertiesConfiguration();
      BufferedWriter bufferedWriter = null;
      FileWriter fileWriter = null;
      try {
        fileWriter = new FileWriter(fileName);
        bufferedWriter = new BufferedWriter(fileWriter);
        propertie.getLayout().setComment("ts_file_name", "[packer_tsfilename]");
        propertie.setProperty("ts_file_name", StringUtil.addQuote(file));
        propertie.getLayout().setBlancLinesBefore("Download_GroupId", 1);
        propertie.getLayout().setComment("Download_GroupId", "[packer_attr]");
        propertie.setProperty("Download_GroupId", 
            StringUtil.convertString(this.upgradeInfo.getDownloadGroupId(), 2));
        propertie.setProperty("Download_PID", 
            StringUtil.convertString(this.upgradeInfo.getDownloadPid(), 2));
        propertie.setProperty("manufacturer_ID", 
            StringUtil.convertString(this.upgradeInfo.getManufacturerId(), 4));
        propertie.setProperty("hardware_version", 
            StringUtil.convertString(this.upgradeInfo.getHardwareVersion(), 8));
        propertie.setProperty("software_version", 
            StringUtil.convertString(this.upgradeInfo.getSoftwareVersion(), 8));
        propertie.setProperty("start_sn", 
            StringUtil.convertString(this.upgradeInfo.getStartSn(), 8));
        propertie.setProperty("end_sn", StringUtil.convertString(this.upgradeInfo.getEndSn(), 8));
        propertie.getLayout().setComment("", "packer_file");
        propertie.getLayout().setBlancLinesBefore("bin_file_num", 1);
        propertie.setProperty("bin_file_num", Integer.valueOf(this.updateFiles.size()));
        for (int i = 1; i <= this.updateFiles.size(); i++) {
          UpgradeFileInfo f = this.updateFiles.get(i - 1);
          String sel = null;
          if (f.isSel()) {
            sel = "1";
          } else {
            sel = "0";
          } 
          propertie.setProperty("flash_sel" + i, sel);
          propertie.setProperty("flash_PartitionName" + i, f.getPartitionName());
          propertie.setProperty("flash_PartitionVersion" + i, 
              Integer.valueOf(f.getPartitionVersion()));
          propertie.setProperty("flash_PartitionVersionTag" + i, 
              Integer.valueOf(f.getPartitionVerifyTag()));
          propertie.setProperty("bin_name" + i, 
              StringUtil.addQuote(f.getFileName()));
          propertie.setProperty("flash_addr" + i, 
              StringUtil.toHexString(f.getStartAddress(), 8));
          propertie.setProperty("flash_type" + i, Integer.valueOf(f.getFlashType().ordinal()));
          propertie.setProperty("flash_system" + i, f.getFileSystem().name());
          propertie.setProperty("flashindex" + i, Integer.valueOf(f.getFlashIndex()));
          propertie.setProperty("file_length" + i, Long.valueOf(f.getLength()));
          propertie.write(bufferedWriter);
        } 
        showMessage(Messages.LoaderComposite_85);
      } catch (IOException e) {
        showError(Messages.LoaderComposite_12);
      } catch (ConfigurationException e) {
        showError(Messages.LoaderComposite_12);
      } finally {
        if (bufferedWriter != null)
          try {
            bufferedWriter.close();
          } catch (IOException iOException) {} 
        if (fileWriter != null)
          try {
            fileWriter.close();
          } catch (IOException iOException) {} 
      } 
    } else if (fileName.toUpperCase().indexOf("XML") > 0) {
      try {
        File out = new File(fileName);
        List<PartitionItem> burn = new ArrayList<>();
        for (int i = 0; i < this.updateFiles.size(); i++) {
          UpgradeFileInfo f = this.updateFiles.get(i);
          f.validateFileName();
          PartitionItem item = new PartitionItem();
          item.setChecked(f.isSel());
          item.setPartitionVersione(f.getPartitionVersion());
          item.setPartitionVersionTag(f.getPartitionVerifyTag());
          item.setFile(new File(f.getFileName()));
          item.setFileSystem(f.getFileSystem());
          item.setFlashType(f.getFlashType());
          item.setLength(f.getLength());
          item.setName(f.getPartitionName());
          item.setStart(f.getStartAddress());
          burn.add(item);
        } 
        PartitionItem.save(out, burn);
        showMessage(Messages.LoaderComposite_85);
      } catch (Exception e) {
        showError(Messages.LoaderComposite_12);
      } 
    } 
  }
  
  protected void setUseXMLPathAsParent(boolean UseXMLPathAsParent) {
    this.useXMLPathAsParent = UseXMLPathAsParent;
  }
  
  private String loadIniFile(String fileName) {
    try {
      SsuIniFileParser parser = new SsuIniFileParser(fileName);
      this.upgradeInfo.setInput(parser, parser.getUpgradeInfo());
      this.ssuTsFileField.setDefaultFileName(GlobleControler.intance.SSU_TS);
      this.updateFiles = parser.getUpgradFiles();
      getViewer().refresh();
    } catch (Exception e) {
      showError(Messages.LoaderComposite_86);
      return "";
    } 
    return fileName;
  }
  
  protected String loadIni() {
    FileDialog dlg = new FileDialog(getShell(), 4100);
    dlg.setFilterNames(INI_FILTER_NAMES);
    dlg.setFilterExtensions(INI_FILTER_EXTS);
    String fileName = dlg.open();
    if (fileName != null) {
      File file = new File(fileName);
      if (!file.exists()) {
        showError(String.format(Messages.UpgradeInfoGroup_FileNotFound, new Object[] { fileName }));
        return "";
      } 
    } 
    if (fileName != null && !fileName.isEmpty()) {
      if (fileName.toUpperCase().endsWith("INI"))
        return loadIniFile(fileName); 
      if (fileName.toUpperCase().endsWith("XML")) {
        List<PartitionItem> load = null;
        try {
          load = PartitionItem.load(new File(fileName), this.useXMLPathAsParent);
        } catch (DocumentException e) {
          showError(Messages.XMLINVALID);
        } 
        if (load == null)
          return ""; 
        if (load.isEmpty())
          try {
            throw new DocumentException();
          } catch (DocumentException documentException) {} 
        try {
          SsuIniFileParser parser = new SsuIniFileParser(load);
          this.ssuTsFileField
            .setDefaultFileName(GlobleControler.intance.SOCT_TS);
          this.upgradeInfo.setInput(parser, parser.getUpgradeInfo());
          this.updateFiles = parser.getUpgradFiles();
        } catch (IOException iOException) {
        
        } catch (InvalidDataFormatException invalidDataFormatException) {}
        return fileName;
      } 
      return "";
    } 
    return "";
  }
  
  private boolean validateInput() {
    if (this.updateFiles.size() == 0) {
      showError(Messages.LoaderComposite_87);
      return false;
    } 
    if (!FileHelper.checkUpgradeFileInfo(this.updateFiles))
      return false; 
    if (this.updateFiles.size() > 256) {
      String message = String.format(Messages.LoaderComposite_88, new Object[] { Integer.valueOf(256) });
      showError(message);
      return false;
    } 
    for (UpgradeFileInfo file : this.updateFiles) {
      try {
        FileUtil.checkAddressConflict(file, this.updateFiles);
      } catch (InvalidDataFormatException e) {
        showError(e.getMessage());
        return false;
      } 
    } 
    if (!this.upgradeInfo.hasInputText())
      return false; 
    if (!this.upgradeInfo.validateInput())
      return false; 
    if (!this.ssuTsFileField.hasInputText(Messages.LoaderComposite_5))
      return false; 
    SsuPackageOptions ssu = this.packageOptionsInfo.getInput();
    if (ssu != null && 
      ssu.getInsertEmptyPacket()) {
      double SymbolRate = ssu.getSymbolRate();
      int ValidSymbolRate = ssu.getValidSymbolRate();
      String message = NLS.bind(Messages.FileSize_Error, new Object[] { Messages.SymbolRate, Messages.ValidSymbolRate });
      if (SymbolRate == ValidSymbolRate || ValidSymbolRate > SymbolRate) {
        MessageDialog.openWarning(Display.getDefault()
            .getActiveShell(), Messages.Warning, message);
        return false;
      } 
    } 
    return true;
  }
  
  public void createLoaderContents(Composite comp) {
    int screenHeight = (Toolkit.getDefaultToolkit().getScreenSize()).height;
    if (screenHeight <= 768) {
      createPartFileContentControl(comp, 100);
    } else {
      createPartFileContentControl(comp, 300);
    } 
    String tsPath = null;
    ArrayList<String> pathList = FileField.loadFilterPath("tempPath.ini");
    for (String str : pathList) {
      if (str.startsWith("ssuitspath"))
        tsPath = str.split("=")[1]; 
    } 
    createUpgradeInfoGroup(comp);
    createPackageOptions(comp);
    createTsGroup(comp, tsPath);
  }
  
  protected String[] getChipList() {
    return CHIPS;
  }
  
  public void start() {
    if (this.ssuTsButton.isDisposed())
      return; 
    this.ssuTsButton.setEnabled(false);
  }
  
  public void stop() {
    if (this.ssuTsButton.isDisposed())
      return; 
    this.ssuTsButton.setEnabled(true);
  }
}
